import AbstractModel from './abstractModel'
import UserModel from './user'
import FileModel from './file'
import type { IUser } from '@/modelTypes/IUser'
import type { IFile } from '@/modelTypes/IFile'
import type { IAttachment } from '@/modelTypes/IAttachment'

export default class AttachmentModel extends AbstractModel implements IAttachment {
	declare id: number
	declare taskId: number
	createdBy: IUser
	file: IFile
	created: Date

	constructor(data: Partial<IAttachment>) {
		super(data)
		this.createdBy = new UserModel(this.createdBy)
		this.file = new FileModel(this.file)
		this.created = new Date(this.created)
	}

	defaults() {
		return {
			id: 0,
			taskId: 0,
			createdBy: UserModel,
			file: FileModel,
			created: null,
		}
	}
}
