import AbstractModel from './abstractModel'
import type {IBackgroundImage} from '@/modelTypes/IBackgroundImage'

export default class BackgroundImageModel extends AbstractModel implements IBackgroundImage {
	declare id: number
	declare url: string
	declare thumb: string
	declare info: {
		author: string
		authorName: string
	}
	declare blurHash: string  

	defaults() {
		return {
			id: 0,
			url: '',
			thumb: '',
			info: {},
			blurHash: '',
		}
	}
}