import AbstractModel from './abstractModel'
import ListModel from './list'

import type {IListDuplicate} from '@/modelTypes/IListDuplicate'
import type {INamespace} from '@/modelTypes/INamespace'
import type {IList} from '@/modelTypes/IList'

export default class ListDuplicateModel extends AbstractModel implements IListDuplicate {
	declare listId: number
	declare namespaceId: INamespace['id']
	list: IList

	constructor(data) {
		super(data)
		this.list = new ListModel(this.list)
	}

	defaults() {
		return {
			listId: 0,
			namespaceId: 0,
			list: ListModel,
		}
	}
}