import AbstractModel from './abstractModel'

import type {ITaskAssignee} from '@/modelTypes/ITaskAssignee'
import type {IUser} from '@/modelTypes/IUser'
import type {ITask} from '@/modelTypes/ITask'

export default class TaskAssigneeModel extends AbstractModel implements ITaskAssignee {
	created: Date
	declare userId: IUser['id']
	declare taskId: ITask['id']

	constructor(data) {
		super(data)
		this.created = new Date(this.created)
	}

	defaults() {
		return {
			created: null,
			userId: 0,
			taskId: 0,
		}
	}
}
