import AbstractModel from './abstractModel'
import UserModel from './user'

import type {ITaskRelation} from '@/modelTypes/ITaskRelation'
import type {ITask} from '@/modelTypes/ITask'
import type {IUser} from '@/modelTypes/IUser'

import type {IRelationKind} from '@/types/IRelationKind'

export default class TaskRelationModel extends AbstractModel implements ITaskRelation {
	declare id: number
	declare otherTaskId: ITask['id']
	declare taskId: ITask['id']
	declare relationKind: IRelationKind

	createdBy: IUser
	created: Date

	constructor(data) {
		super(data)
		this.createdBy = new UserModel(this.createdBy)
		this.created = new Date(this.created)
	}

	defaults() {
		return {
			id: 0,
			otherTaskId: 0,
			taskId: 0,
			relationKind: '',

			createdBy: UserModel,
			created: null,
		}
	}
}