
import AbstractModel from './abstractModel'

import type {IUserSettings} from '@/modelTypes/IUserSettings'
import type {IList} from '@/modelTypes/IList'

export default class UserSettingsModel extends AbstractModel implements IUserSettings {
	declare name: string
	declare emailRemindersEnabled: boolean
	declare discoverableByName: boolean
	declare discoverableByEmail: boolean
	declare overdueTasksRemindersEnabled: boolean
	declare defaultListId: undefined | IList['id']
	declare weekStart: IUserSettings['weekStart']
	declare timezone: string

	defaults() {
		return {
			name: '',
			emailRemindersEnabled: true,
			discoverableByName: false,
			discoverableByEmail: false,
			overdueTasksRemindersEnabled: true,
			defaultListId: undefined,
			weekStart: 0,
			timezone: '',
		}
	}
}