import AbstractModel from './abstractModel'

import {RIGHTS, type Right} from '@/modelTypes/constants/rights'
import type {IUserShareBase} from '@/modelTypes/IUserShareBase'
import type {IUser} from '@/modelTypes/IUser'

export default class UserShareBaseModel extends AbstractModel implements IUserShareBase {
	declare userId: IUser['id']
	declare right: Right

	created: Date
	updated: Date

	constructor(data) {
		super(data)
		this.created = new Date(this.created)
		this.updated = new Date(this.updated)
	}

	defaults() {
		return {
			userId: '',
			right: RIGHTS.READ,

			created: null,
			updated: null,
		}
	}
}